// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - UI
// Contains MOUSE functions, simple
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// TODO: MAKE THIS A CVAR
#define CURSOR_BASEMULT			1.25

// ------------------------/
// Is the mouse within a certain bounding box?
// ------------------------/

bool MouseInRect(int x1, int y1, int x2, int y2)
{
	if (GetMouseX() >= x1 && GetMouseY() >= y1 && GetMouseX() <= x2 && GetMouseY() <= y2)
		return true;
		
	return false;
}

// ------------------------/
// Mouse is within a bounding box
// ------------------------/

bool Mousing(struct Rect& Box)
{
	int MX = GetMouseX();
	int MY = GetMouseY();
	
	if (MX >= Box.X && MX <= Box.X+Box.W && MY >= Box.Y && MY <= Box.Y+Box.H)
		return true;
		
	return false;
}

// ------------------------/
// Get mouse X
// ------------------------/

int GetMouseX (void)
{
	return GameState.HUD.MouseX;
}

// ------------------------/
// Get Mouse Y
// ------------------------/

int GetMouseY (void)
{
	return GameState.HUD.MouseY;
}

// ------------------------/
// Actually HANDLE the mouse cursor!
// ------------------------/

void UpdateCursor(bool drawAfter = false)
{
	int speedX, speedY;
	int sensitivity = GetCVar("mouse_sensitivity");

	// How much to scale our mouse movement
	speedX = FixedDiv(1.0, FixedMul(GetCVar("m_yaw"), sensitivity) );
	speedY = FixedDiv(1.0, FixedMul(GetCVar("m_pitch"), sensitivity) );
	
	// Scale them up a bit to make them "normal"
	speedX = FixedMul(2.5, speedX);
	speedY = FixedMul(5.0, speedY);
	
	// Plain speed just isn't fast enough, raise it a bit!
	speedX = FixedMul(speedX, CURSOR_BASEMULT);
	speedY = FixedMul(speedY, CURSOR_BASEMULT);
	
	int CPN = ConsolePlayerNumber();
	
	// Delta speed
	int dx = -FixedMul(GetPlayerInput(CPN, INPUT_YAW), speedX);
	int dy = -FixedMul(GetPlayerInput(CPN, INPUT_PITCH), speedY);
	
	// Convert to absolute pixels
	// This prevents us from having to do it with every rect check
	int ResX = GetScreenWidth() * 1.0;
	int ResY = GetScreenHeight() * 1.0;
	
	dx = FixedMul(dx, ResX);
	dy = FixedMul(dy, ResY);
	
	GameState.HUD.MouseX += dx;
	GameState.HUD.MouseY += dy;
	
	GameState.HUD.MouseX = clamp(GameState.HUD.MouseX, 0.0, ResX);
	GameState.HUD.MouseY = clamp(GameState.HUD.MouseY, 0.0, ResY);
	
	// Draw the cursor afterwards?
	if (drawAfter)
		DrawCursor();
}

// ------------------------/
// Draw the cursor on-screen!
// ------------------------/

void DrawCursor(str pic = "cursorp3")
{
	// Clear it!
	if (pic == "")
	{
		ClearHUDMessage(HID_CURSOR);
		return;
	}
	
	SetFont(pic);
	HUDMessageUnscaled( GetMouseX(), GetMouseY(), "a", ALIGN_LEFT, ALIGN_TOP, HID_CURSOR);
}