// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - PLAYLIST CORE
// Backend functionality for most playlist garbage
//
// This code is very repetitive and sloppy, I know
//
// Server plays the actual music, client shows the info for it
//
// We play music on the server so players who join late
// can (hopefully) hear the current track
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

#define MAX_SONGS				64;
#define MAX_CUSTOM_SONGS		16;
#define MAX_BOSS_SONGS			4;

enum SongType
{
	SONG_COMBAT,
	SONG_CALM,
	SONG_BOSS,
	SONG_CUSTOMCOMBAT,
	SONG_CUSTOMCALM,
	SONG_CUSTOMBOSS
};

// All information about a given music track

struct PlaylistEntry
{
	int Hash;				// Unique hash / checksum for this entry
	str Title;				// Song name
	str Author;				// Song author
	str Track;				// Actual music file to play
};

// The MAIN music controller
// We have a few arrays, so just pack them in here
// (This probably takes up a lot of memory, but who knows)

struct JukeboxData
{
	struct PlaylistEntry CombatSongs[MAX_SONGS];
	struct PlaylistEntry CalmSongs[MAX_SONGS];
	struct PlaylistEntry BossSongs[MAX_BOSS_SONGS];
	
	struct PlaylistEntry MapCombatSongs[MAX_CUSTOM_SONGS];
	struct PlaylistEntry MapCalmSongs[MAX_CUSTOM_SONGS];
	struct PlaylistEntry MapBossSongs[MAX_BOSS_SONGS];
	
	int CombatSongCount;
	int CalmSongCount;
	int MapCombatSongCount;
	int MapCalmSongCount;
	int BossSongCount;
	int MapBossSongCount;
	
	// These are used to prevent back-to-back playing
	int LastCombatSong, LastCalmSong, LastBossSong;
	
	// Use custom lists for these?
	bool custCombat, custCalm, custBoss;
	
	// The first-joining player has played the initial calm song
	bool HasPlayedInitial;
};

struct JukeboxData Jukebox;

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Reset combat songs
// ------------------------/

void ResetCombatSongs(bool custom = false)
{
	if (custom)
		Jukebox.MapCombatSongCount = 0;
	else
		Jukebox.CombatSongCount = 0;
}

// ------------------------/
// Reset calm songs
// ------------------------/

void ResetCalmSongs(bool custom = false)
{
	if (custom)
		Jukebox.MapCalmSongCount = 0;
	else
		Jukebox.CalmSongCount = 0;
}

// ------------------------/
// Reset boss songs
// ------------------------/

void ResetBossSongs(bool custom = false)
{
	if (custom)
		Jukebox.MapBossSongCount = 0;
	else
		Jukebox.BossSongCount = 0;
}

// ------------------------/
// Add an actual song to the playlist!
// ------------------------/

void AddPlaylistSong(int SongType, str sTit, str sAut, str sTrk)
{
	int theHash = CRC(StrParam(s:sTit, s:sTrk));
	
	switch (songType)
	{
		//-- COMBAT
		case SONG_COMBAT:
			Jukebox.CombatSongs[Jukebox.CombatSongCount].Title = sTit;
			Jukebox.CombatSongs[Jukebox.CombatSongCount].Author = sAut;
			Jukebox.CombatSongs[Jukebox.CombatSongCount].Track = sTrk;
			Jukebox.CombatSongs[Jukebox.CombatSongCount].Hash = theHash;
			Jukebox.CombatSongCount ++;
			break;
			
		//-- CALM
		case SONG_CALM:
			Jukebox.CalmSongs[Jukebox.CalmSongCount].Title = sTit;
			Jukebox.CalmSongs[Jukebox.CalmSongCount].Author = sAut;
			Jukebox.CalmSongs[Jukebox.CalmSongCount].Track = sTrk;
			Jukebox.CalmSongs[Jukebox.CalmSongCount].Hash = theHash;
			Jukebox.CalmSongCount ++;
			break;
			
		//-- BOSS
		case SONG_BOSS:
			Jukebox.BossSongs[Jukebox.BossSongCount].Title = sTit;
			Jukebox.BossSongs[Jukebox.BossSongCount].Author = sAut;
			Jukebox.BossSongs[Jukebox.BossSongCount].Track = sTrk;
			Jukebox.BossSongs[Jukebox.BossSongCount].Hash = theHash;
			Jukebox.BossSongCount ++;
			break;
			
		//-- CUSTOM COMBAT
		case SONG_CUSTOMCOMBAT:
			Jukebox.custCombat = true;
			Jukebox.MapCombatSongs[Jukebox.MapCombatSongCount].Title = sTit;
			Jukebox.MapCombatSongs[Jukebox.MapCombatSongCount].Author = sAut;
			Jukebox.MapCombatSongs[Jukebox.MapCombatSongCount].Track = sTrk;
			Jukebox.MapCombatSongs[Jukebox.MapCombatSongCount].Hash = theHash;
			Jukebox.MapCombatSongCount ++;
			break;
			
		//-- CUSTOM CALM
		case SONG_CUSTOMCALM:
			Jukebox.custCalm = true;
			Jukebox.MapCalmSongs[Jukebox.MapCalmSongCount].Title = sTit;
			Jukebox.MapCalmSongs[Jukebox.MapCalmSongCount].Author = sAut;
			Jukebox.MapCalmSongs[Jukebox.MapCalmSongCount].Track = sTrk;
			Jukebox.MapCalmSongs[Jukebox.MapCalmSongCount].Hash = theHash;
			Jukebox.MapCalmSongCount ++;
			break;
			
		//-- CUSTOM BOSS
		case SONG_CUSTOMBOSS:
			Jukebox.custBoss = true;
			Jukebox.MapBossSongs[Jukebox.MapBossSongCount].Title = sTit;
			Jukebox.MapBossSongs[Jukebox.MapBossSongCount].Author = sAut;
			Jukebox.MapBossSongs[Jukebox.MapBossSongCount].Track = sTrk;
			Jukebox.MapBossSongs[Jukebox.MapBossSongCount].Hash = theHash;
			Jukebox.MapBossSongCount ++;
			break;
	}
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Find the index of a combat song to use
// ------------------------/

int DecideCombatSong()
{
	int checker = Jukebox.LastCombatSong;
	
	// Only ONE SONG
	int sCount = Jukebox.custCombat ? Jukebox.MapCombatSongCount : Jukebox.CombatSongCount;
		
	if (sCount == 1)
		return 0;
	
	while (checker == Jukebox.LastCombatSong)
		checker = random(0, sCount-1);
	
	// Should have a new track
	Jukebox.LastCombatSong = checker;
	return checker;
}

// ------------------------/
// Find the index of a calm song to use
// ------------------------/

int DecideCalmSong()
{
	int checker = Jukebox.LastCalmSong;
	
	// Only ONE SONG
	int sCount = Jukebox.custCalm ? Jukebox.MapCalmSongCount : Jukebox.CalmSongCount;
	if (sCount == 1)
		return 0;
	
	while (checker == Jukebox.LastCalmSong)
		checker = random(0, sCount-1);
	
	// Should have a new track
	Jukebox.LastCalmSong = checker;
	return checker;
}

// ------------------------/
// Find the index of a boss song to use
// ------------------------/

int DecideBossSong()
{
	int checker = Jukebox.LastBossSong;
	
	// Only ONE SONG
	int sCount = Jukebox.custBoss ? Jukebox.MapBossSongCount : Jukebox.BossSongCount;
	if (sCount == 1)
		return 0;
	
	while (checker == Jukebox.LastBossSong)
		checker = random(0, sCount-1);
	
	// Should have a new track
	Jukebox.LastBossSong = checker;
	return checker;
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// ------------------------/
// Easy access function (SERVER)
// ------------------------/

void PlayCombatSong()
{
	int ind = DecideCombatSong();

	ACS_NamedExecuteAlways("PlayMusicTrack_Rep", 0, SONG_COMBAT, Jukebox.custCombat ? Jukebox.MapCombatSongs[ind].Hash : Jukebox.CombatSongs[ind].Hash);
	SetMusic(Jukebox.custCombat ? Jukebox.MapCombatSongs[ind].Track : Jukebox.CombatSongs[ind].Track);
}

// ------------------------/
// Easy access function (SERVER)
// ------------------------/

void PlayCalmSong()
{
	int ind = DecideCalmSong();
	
	ACS_NamedExecuteAlways("PlayMusicTrack_Rep", 0, SONG_CALM, Jukebox.custCalm ? Jukebox.MapCalmSongs[ind].Hash : Jukebox.CalmSongs[ind].Hash);
	SetMusic(Jukebox.custCalm ? Jukebox.MapCalmSongs[ind].Track : Jukebox.CalmSongs[ind].Track);
}

// ------------------------/
// Easy access function (SERVER)
// ------------------------/

void PlayBossSong()
{
	int ind = DecideBossSong();
	
	ACS_NamedExecuteAlways("PlayMusicTrack_Rep", 0, SONG_BOSS, Jukebox.custBoss ? Jukebox.MapBossSongs[ind].Hash : Jukebox.BossSongs[ind].Hash);
	SetMusic(Jukebox.custBoss ? Jukebox.MapBossSongs[ind].Track : Jukebox.BossSongs[ind].Track);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Received a hash and type, let's update the info!

void ParsePlaylistRequest(int type, int hash)
{
	int i, cnt, check;
	str tit = "???";
	str aut = "???";
	
	ZTPrint("PARSEREQUEST");
	
	switch (type)
	{
		// -- Combat ---------------------------
		case SONG_COMBAT:
			cnt = Jukebox.custCombat ? Jukebox.MapCombatSongCount : Jukebox.CombatSongCount;
			for (i=0; i<cnt; i++)
			{
				check = Jukebox.custCombat ? Jukebox.MapCombatSongs[i].Hash  : Jukebox.CombatSongs[i].Hash;
				if (check == hash)
				{
					tit = Jukebox.custCombat ? Jukebox.MapCombatSongs[i].Title  : Jukebox.CombatSongs[i].Title;
					aut = Jukebox.custCombat ? Jukebox.MapCombatSongs[i].Author  : Jukebox.CombatSongs[i].Author;
					break;
				}
			}
			break;
			
		// -- Calm -----------------------------
		case SONG_CALM:
			cnt = Jukebox.custCalm ? Jukebox.MapCalmSongCount : Jukebox.CalmSongCount;
			for (i=0; i<cnt; i++)
			{
				check = Jukebox.custCalm ? Jukebox.MapCalmSongs[i].Hash  : Jukebox.CalmSongs[i].Hash;
				if (check == hash)
				{
					tit = Jukebox.custCalm ? Jukebox.MapCalmSongs[i].Title  : Jukebox.CalmSongs[i].Title;
					aut = Jukebox.custCalm ? Jukebox.MapCalmSongs[i].Author  : Jukebox.CalmSongs[i].Author;
					break;
				}
			}
			break;
			
		// -- Boss -----------------------------
		case SONG_BOSS:
			cnt = Jukebox.custBoss ? Jukebox.MapBossSongCount : Jukebox.BossSongCount;
			for (i=0; i<cnt; i++)
			{
				check = Jukebox.custBoss ? Jukebox.MapBossSongs[i].Hash  : Jukebox.BossSongs[i].Hash;
				if (check == hash)
				{
					tit = Jukebox.custBoss ? Jukebox.MapBossSongs[i].Title  : Jukebox.BossSongs[i].Title;
					aut = Jukebox.custBoss ? Jukebox.MapBossSongs[i].Author  : Jukebox.BossSongs[i].Author;
					break;
				}
			}
			break;
	}
	
	ShowTrackInfo(tit, aut);
}