// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2 - PERK LIST [CORE]
// Core code related to the perk list
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

struct PerkListEntry
{
	str ID;						// Shorthand ID to use for the perk
	str DisplayName;			// Name to show this perk as
	str Description;			// Description to use
	int Hash;					// Hash based on the perk's ID
	bool Hidden;				// Unselectable
	
	str IconHUD;				// Icon to show on HUD
	str IconSelect;				// Icon to show in perk select
	
	str GrenadeClass;			// Class of the grenade WEAPON to use
};

struct PerkListEntry PerkList[MAX_PERKS];
int PerkListSize;

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void PerkifyWep(str wClass, str perkID)
{
	int WI = WeaponByType(wClass);
	if (WI == -1)
		return;
		
	int PI = PerkByID(perkID);
	if (PI == -1)
		return;
		
	RegisterWeaponPerk(PI, WI);
}

// ------------------------/
// Register a perk to the core list
// ------------------------/

void RegisterPerk(str ID, str Display)
{
	PerkList[PerkListSize].ID = ID;
	PerkList[PerkListSize].DisplayName = Display;
	
	// Generate a hash
	PerkList[PerkListSize].Hash = FakeHash(ID);
	
	// Description
	PerkList[PerkListSize].Description = "No perk bonus information exists for this perk. Maybe you can add some! Either way, this will be auto-wrapped in the box.\n\n(Change this later.)";
	
	PerkList[PerkListSize].IconHUD = "PHUDGREN";
	
	// fix later
	PerkList[PerkListSize].GrenadeClass = "Type97Grenade";
	
	PerkListSize ++;
}

// ------------------------/
// Register a perk's icon
// ------------------------/

void RegisterPerkIcon(str iHUD, str iSel)
{
	PerkList[PerkListSize-1].IconHUD = iHUD;
	PerkList[PerkListSize-1].IconSelect = iSel;
}

// ------------------------/
// Disable a perk
// ------------------------/

void SetPerkDisabled(bool dis = true)
{
	PerkList[PerkListSize-1].Hidden = dis;
}

// ------------------------/
// Find a perk by its hash
// ------------------------/

int PerkByHash(int hash)
{
	for (int i=0; i<PerkListSize; i++)
	{
		if (PerkList[i].Hash == hash)
			return i;
	}
	
	return -1;
}

// ------------------------/
// Find a perk by its ID
// ------------------------/

int PerkByID(str pID)
{
	for (int i=0; i<PerkListSize; i++)
	{
		if (StrCmp(PerkList[i].ID, pID) == 0)
			return i;
	}
	
	return -1;
}