// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ZOMBIE TORRENT 2: HEALING
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// How frequently to give juice
#define HEAL_RECHARGE_RATE					6

// How much juice to give
#define HEAL_RECHARGE_GIVER					1

namespace ZTHealingCode
{
	int HealTick;
	
	// ------------------------/
	// Is healing allowed?
	// ------------------------/

	bool HealingAllowed()
	{
		if (GetActorProperty(0, APROP_HEALTH) >= MAXIMUM_HEALTH)
			return false;
		
		if (CheckInventory("SyringeJuice") < GetAmmoCapacity("SyringeJuice"))
			return false;
			
		return true;
	}

	script "HealingAllowed" { SetResultValue(HealingAllowed()); }

	// ------------------------/
	// Tick script for handling heals
	// ------------------------/

	void Healing_Tick()
	{
		// -- GIVE SYRINGE JUICE!
		if (CheckInventory("SyringeJuice") < GetAmmoCapacity("SyringeJuice"))
		{
			HealTick ++;
			
			if (HealTick >= HEAL_RECHARGE_RATE)
			{
				HealTick = 0;
				GiveInventory("SyringeJuice", HEAL_RECHARGE_GIVER);
				
				// Full?
				if (CheckInventory("SyringeJuice") >= GetAmmoCapacity("SyringeJuice"))
					ACS_NamedExecuteAlways("HealingBlipper", 0);
			}
		}
	}
	
	// ------------------------/
	// SERVER -> CLIENT
	// Blip on the HUD
	// ------------------------/
	
	script "HealingBlipper" CLIENTSIDE
	{
		if (WrongClient())
			terminate;
			
		LocalAmbientSound("heal/blip", 127);
		InvEnsure("SyringeBlip", 1);
		delay(2);
		InvEnsure("SyringeBlip", 0);
	}

}